import React, { Component } from 'react'
import { render } from 'react-dom'

import { UnControlled as CodeMirror } from 'react-codemirror2'
import Mirror from 'codemirror/lib/codemirror';
import 'codemirror/lib/codemirror.css';
import 'codemirror/mode/sql/sql';
import 'codemirror/addon/hint/show-hint.css';
import 'codemirror/addon/hint/show-hint.js';
import 'codemirror/addon/hint/sql-hint.js';
import 'codemirror/theme/rubyblue.css';
import './editor';

export default class CodeMirrorWrap extends Component {
    constructor() {
        super();
    }

    componentDidMount() {
        Mirror.keywords = this.props.keywords;
    }

    componentWillReceiveProps(nextProps) {
        if (this.props.keywords !== nextProps.keywords) {
            Mirror.keywords = nextProps.keywords;
        }
    }

    render() {
        const options = {
            lineNumbers: true,                     //显示行号  
            mode: {
                name: "text/x-mysql",
            },          //定义mode  
            extraKeys: {
                "Ctrl": "autocomplete"

            },   //自动提示配置  
            theme: "rubyblue",                  //选中的theme  
            codeMirrorInstance: Mirror
        };

        return (
            <CodeMirror
                ref="editor-sql"
                value={this.props.value}
                options={options}
                onBeforeChange={(editor, data, value) => {
                    this.setState({ value });
                }}
                onChange={(editor, data, value) => {}}
            />
        )
    }
}
